      subroutine fillmat ( mat, nx, ny, phi, bval, slacar)
c ======================================================================
c
c        programmer     Jos van Kan
c        version 1.0    date   01-01-1997
c
c
c
c   copyright (c) 1997
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   author.
c
c   pilotcode 2d mgpackage
c
c **********************************************************************
c
c                       DESCRIPTION
c
c
c
c **********************************************************************
c
c                       KEYWORDS
c
c **********************************************************************
c
c                       MODULES USED
c
      use mgpreset
c     use testmod
c
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      integer slacar (4)
      integer nx, ny, bval
      double precision
     + mat (1-slacar(1):nx+slacar(2), 1-slacar(3):ny+slacar(4), 9)
     + ,phi

c   mat             the 9 x nx x ny coefficient matrix of the
c                   discrete Laplacian
c   nx              number of grid x points on finest grid
c   ny              number of grid y points on finest grid
c   xslacklo          slack space around array (lb first coordinate)
c   xslackhi          slack space around array (ub first coordinate)
c   yslacklo          slack space around array (lb second coordinate)
c   yslackhi          slack space around array (ub second coordinate)
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer ix, iy
      double precision cx, cy, cxy, dx, dy, e, rphi
      double precision g11, g12, g22

c   ix              counter to number of grid x points on finest grid
c   iy              counter to number of grid y points on finest grid
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      dx = 1d0/(nx + 1)
      dy = 1d0/(ny + 1)
      e  = dy/dx
      rphi = atan (1d0) / 45d0 * phi
      g11 = 1d0
      g12 = -cos (rphi)/sin(rphi)
      g22 = (1 + cos (rphi)**2)/sin(rphi)**2
      cx = g11*e
      cy = g22/e
      cxy = 0.5d0*g12
      do iy = 1, ny
        do ix = 1, nx
           mat (ix, iy, p11) = 2d0 * (cx + cy)
        end do

        do ix = 1, nx-1
           mat (ix, iy, p20) = -cxy
           mat (ix, iy, p21) = -cx
           mat (ix, iy, p22) = cxy
        end do
        mat (nx, iy, p20) = 0d0
        mat (nx, iy, p21) = 0d0
        mat (nx, iy, p22) = 0d0

        do ix = 2, nx
           mat (ix, iy, p00) = cxy
           mat (ix, iy, p01) = -cx
           mat (ix, iy, p02) = -cxy
        end do
        mat (1, iy, p00) = 0d0
        mat (1, iy, p01) = 0d0
        mat (1, iy, p02) = 0d0

        if (iy.ne.1) then
          do ix = 1, nx
           mat (ix, iy, p10) = -cy
          end do
        else
          do ix = 1, nx
           mat (ix, iy, p00) = 0d0
           mat (ix, iy, p10) = 0d0
           mat (ix, iy, p20) = 0d0
          end do
        end if

        if (iy.ne.ny) then
          do ix = 1, nx
           mat (ix, iy, p12) = -cy
          end do
        else
          do ix = 1, nx
           mat (ix, iy, p02) = 0d0
           mat (ix, iy, p12) = 0d0
           mat (ix, iy, p22) = 0d0
          end do
        end if
      end do
      if (bval .eq. 1) then
      do ix = 1, nx
         mat (ix, ny, p11) = mat (ix, ny, p11) - cy
      end do
      do iy = 1, ny
         mat (nx, iy, p11) = mat (nx, iy, p11) - cx
c         mat (1, iy, p11) = mat (1, iy, p11) -cx
      end do
      endif
      end
