      function maxvec ( vec, nxa, nya, sl1, sl2, sl3, sl4)
c ======================================================================
c
c        programmer     Jos van Kan
c
c       version 1.0    27-03-1997
c
c
c   copyright (c) 1997
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   author.
c
c
c **********************************************************************
c
c                       DESCRIPTION
c
c   Calculates infinity norm of vec
c
c **********************************************************************
c
c                       KEYWORDS
c
c   multi_grid
c
c **********************************************************************
c
c                       INPUT / OUTPUT PARAMETERS
c
      implicit none
      double precision maxvec
      integer sl1, sl2, sl3, sl4
      integer nxa, nya
      double precision
     + vec (1-sl1:nxa+sl2, 1-sl3:nya+sl4)

c     maxvec         Infinity norm
c     nxa       i    Number of grid x points on this level
c     nya       i    Number of grid y points on this level
c     sl1       i    Slack variable, x lower bound
c     sl2       i    Slack variable, x upper bound
c     sl3       i    Slack variable, y lower bound
c     sl4       i    Slack variable, y upper bound
c     vec       i    Generic name for quantity with the dimension of
c                    sol or rhs
c **********************************************************************
c
c                       COMMON BLOCKS
c
c **********************************************************************
c
c                       LOCAL PARAMETERS
c
      integer ixa, iya
      double precision aux

c     aux       Auxiliary variable
c     ixa       Counter to number of grid x points on this level
c     iya       Counter to number of grid y points on this level
c **********************************************************************
c
c                       SUBROUTINES CALLED
c
c **********************************************************************
c
c                       I/O
c
c **********************************************************************
c
c                       ERROR MESSAGES
c
c **********************************************************************
c
c                       PSEUDO CODE
c
c **********************************************************************
c
c                       DATA STATEMENTS
c
c ======================================================================
c
      aux = 0d0
      do iya = 1, nya
        do ixa = 1, nxa
        if (abs (vec (ixa, iya)).gt.aux) then
           aux = abs (vec (ixa, iya))
        end if
        end do
      end do
      maxvec = aux
      end
